local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
-- Modules
local Assert = BaikCore.Assert
local Debug = BaikCore.Debug

-- Add Module to BaikCore
local Log = BaikCore:NewModule("Log")
BaikCore.Log = Log

-- Private Methods
local function PrintTag(tag, fmt, ...)
    Assert:String(tag)
    Assert:String(fmt)
    BaikCore:Print(tag .. ": " .. string.format(fmt, ...))
end

-- Public API
function Log:e(fmt, ...)
    PrintTag("ERROR", fmt, ...)
end

function Log:w(fmt, ...)
    if Debug:IsWarn() then
        PrintTag("WARN", fmt, ...)
    end
end

function Log:d(fmt, ...)
    if Debug:IsDebug() then
        PrintTag("DEBUG", fmt, ...)
    end
end

function Log:i(fmt, ...)
    if Debug:IsInfo() then
        PrintTag("INFO", fmt, ...)
    end
end

function Log:v(fmt, ...)
    if Debug:IsVerbose() then
        PrintTag("VERBOSE", fmt, ...)
    end
end
